#############################################################################
##  
##  PackageInfo.g for the package `Cohomology'                  Marcus Bishop
##  (created from Frank Lbeck's PackageInfo.g template file)

SetPackageInfo( rec(
  PackageName := "Cohomology",
  Subtitle := "A GAP Package to Calculate Group Cohomology",
  Version := "0.1",
  Date := "22/05/2006",
  ArchiveURL := 
    "http://mad.epfl.ch/~bishop/Cohomology/cohomology-0.1.tar.gz",
  ArchiveFormats := ".tar.gz",

  Persons := [
    rec( 
      LastName      := "Bishop",
      FirstNames    := "Marcus",
      IsAuthor      := true,
      IsMaintainer  := true,
      Email         := "marcus.bishop@epfl.ch",
      WWWHome       := "http://people.epfl.ch/marcus.bishop",
      PostalAddress := Concatenation([
                         "EPFL SB IGAT MAD\n",
                         "MA C3 615 (Btiment MA)\n",
                         "Station 8\n",
                         "CH-1015 Lausanne\n",
                         "Switzerland"
                        ]),
      Place         := "Lausanne",
      Institution   := "EPFL"
    )
  ],
  Status := "dev",
  README_URL := 
    "http://mad.epfl.ch/~bishop/Cohomology/README",
  PackageInfoURL:=
    "http://mad.epfl.ch/~bishop/Cohomology/PackageInfo.g",
  AbstractHTML := Concatenation([
    "This package computes the cohomology ring ",
    "of finite p-groups, induced maps, and ",
    "Massey products.\n"
  ]),
  PackageWWWHome:= 
    "http://mad.epfl.ch/~bishop/Cohomology",

  PackageDoc := rec(
    BookName      := "Cohomology",
    ArchiveURLSubset := ["doc"],
    HTMLStart     := "doc/chap0.html",
    PDFFile       := "doc/manual.pdf",
    SixFile       := "doc/manual.six",
    LongTitle     := "The Group Cohomology Package",
    Autoload      := true
  ),

  Dependencies := rec(
    GAP := ">=4.4",
    NeededOtherPackages := [],
    SuggestedOtherPackages := [],
    ExternalConditions := []
  ),

  AvailabilityTest := ReturnTrue,
  #BannerString:="And so it goes\n",
  BannerString:=Concatenation([
    "\nLast night I was on the threshold of hell.\n",
    "To-day, I am within sight of my heaven.\n",
    "         -Emily Bronte, Wuthering Heights.\n"
  ]),
  Autoload := false,
  TestFile := "tst/test.g",
  Keywords := ["cohomology"],
));
