InstallGlobalFunction(PCGens,function(G,K)
  local m,I,P,F,M,g,H,X,Y;
  m:=ChangeOfBasisMatrix(G,K);
  I:=IdentityMat(Size(G),K);
  
  # Generate a minimal generating set for G.
  P:=Pcgs(G);
  F:=FrattiniSubgroup(G);
  M:=[];
  for g in P do
    H:=Subgroup(G,Concatenation(Elements(F),[g]));
    if Size(H)>Size(F) then
      Append(M,[g]); 
      F:=H;
    fi;
    if Size(F)=Size(G) then break;fi;
  od;
  
  # Both of the following lists give the action of the g-1's on kG.
  # The second list is minimal.
  X:=List(_RegularModule(G,K),x->m*(x-I)*Inverse(m));
  Y:=ListX([1..Size(P)],x->P[x] in M,x->X[x]);
  return [X,Y];
  end
);
