InstallGlobalFunction(ChangeOfBasisMatrix,function(G,K)
  local A,e,i,P,L,OldB,NewB,m;
  A:=GroupRing(K,G);
  e:=Embedding(G,A);
  i:=One(A);
  P:=Pcgs(G);
  L:=ReverseLex(G);
  OldB:=List(L,x->x^e);
  NewB:=List(L,x->Product([1..Size(P)],y->
  	(i*PcElementByExponents(P,Kronecker(1,Size(P),y))-i)
  	^ExponentOfPcElement(P,x,y)));
  
  # OldB is the list of the elements g of G as elements of kG.
  # NewB is the list of the elements g-1 of G as elemenets of kG.
  
  m:=List(NewB,x->Coefficients(Basis(A,OldB),x));
  ConvertToMatrixRep(m);
  return m;
  end
);
  
# The matrix returned is the change-of-basis matrix m
# going from the NewB to OldB, that is,
# right multiplication by m of a row vector
# with respect to NewB gives a row vector
# with respect to OldB.
