InstallGlobalFunction(GeneratorsOfRadical,function(d,L) 
  # L should be the minimal list of g-1's acting on kG.
  local K,I,N,n,NG,V,W,B;
  
  K:=DefaultFieldOfMatrix(L[1]);
  N:=NullspaceMat(d);
  n:=Size(N[1])/Size(L[1]); # n is the number of block columns, 
  
  NG:=Concatenation(List(L,x->N*GxGxG(x,n)));
  V:=VectorSpace(K,N);
  W:=Subspace(V,NG);
  B:=ExtendToBasis(V,Basis(W));
  return List([Dimension(W)+1..Dimension(V)],x->B[x]);
  end
);  
