# This is a modified version of the library 
# function RegularModule by Bettina Eick.
# Returns a list of matrices giving the actions
# of g on kG for all g in Pcgs(G).
  
InstallGlobalFunction(_RegularModule,function( G, F )
  local gens, mats, elms, d, zero, i, mat, j, o;
  gens := Pcgs(G);
  mats := List( gens, x -> false );
  elms := ReverseLex(G);
  d    := Length(elms);
  zero := NullMat( d, d, F );
  for i in [1..Length( gens )] do
    mat := List( zero, ShallowCopy ); 
    for j in [1..d] do
      o := Position( elms, elms[j]*gens[i] );
      mat[j][o] := One( F );
    od;
    ConvertToMatrixRep(mat);
    mats[i] := mat;
  od;
  return  mats;
  end
);
