InstallGlobalFunction(ProductOfChainMaps,function(E,e,F,f,C)
  # e=Deg(E),f=Deg(F). 
  # You get more lifts if e>f rather than f>e.
  # Just an observation.
  return List([1..Size(E)-f],
    j->E[j+f]*LiftHom(C!.L[1],F[j]));
  end
);

InstallGlobalFunction(NiceIndeterminate,function(C,n)
  # I can't spell the alphabet backwards without looking.
  local L;
  L:=["z","y","x","w","v","u","t","s","r","q","p"];
  return X(C!.K,L[n]);
  end
);

InstallMethod(CohomologyRelators,
"Computes cohomology relators to degree n",
[IsCObject,IsPosInt], 

function(C,n)
local F,G,M,S,I,d,L,c,x,y,z,w,N,s,k;
CohomologyGenerators(C,n);

if not IsBound(C!.V) or Size(C!.V) < Size(C!.D) then 
# Of course, you shouldn't be calling this function
# until you've discovered all the generators...
  if(Size(C!.D)>11) then
    C!.V:=List([1..Size(C!.D)],x->X(C!.K,x));
  else
    C!.V:=List([1..Size(C!.D)],x->NiceIndeterminate(C,x));
  fi;
fi;
F:=PolynomialRing(C!.K,C!.V);

G:=List([1..Size(C!.D)],
  j->[C!.D[j],C!.V[j],C!.H[j]]);
M:=SetX(G,x->x[1]=1,ShallowCopy); # The monomials that remain.
S:=[];                            # The final answer goes here.
I:=[];                            # The leading monomials of S.
for d in [2..n] do
  L:=Set([]); # to be considered Later.
  c:=[]; # already Considered this round.
  for x in M do
    for y in G do
      if x[1]+y[1]=d then
        z:=x[2]*y[2];
        if not z in c then
          Append(c,[z]);
          if not Zero(F)=PolynomialReducedRemainder( # if z in I
            z,I,MonomialLexOrdering()) then
            #w:=x[3][y[1]+1]*LiftHom(C!.L[1],y[3][1]); # w=x*y
            w:=ExtractColumn(LiftHom(
              C!.L[1],x[3][y[1]+1]*LiftHom(C!.L[1],y[3][1])),1); 
            if w=0*w then # if this monomial happens to be a relator...
              Append(I,[z]);
              Append(S,[z]);
            else
              Append(L,[[z,w,x,y]]);
            fi;
          fi;
        fi;
      fi;
    od; # end y
  od; # end x
  Sort(L); # What is this all about?
  L:=Reversed(L);
  if(Size(L)<>0) then 
    N:=TriangulizedNullspaceMat(List(L,x->x[2]));
    s:=List(N,k->Sum([1..Size(L)],j->k[j]*L[j][1]));
    for x in s do
      k:=LeadingMonomialOfPolynomial(x,MonomialLexOrdering());
      RemoveElmList(L,Position(L,ListX(L,j->k=j[1],j->j)[1]));
      if not Zero(F)=PolynomialReducedRemainder(
        x,S,MonomialLexOrdering()) then # Perhaps if not in I?
        Append(S,[x]);
	Append(I,[k]);
      fi;
    od;
  fi;
  Append(M,Concatenation(
    List(L,j->[j[3][1]+j[4][1],j[1],ProductOfChainMaps(
      j[3][3],j[3][1],j[4][3],j[4][1],C)]),
    ListX(G,j->d=j[1],j->j))
    );
od; # end d

return [C!.V,S];
end
);
