InstallGlobalFunction(AugmentSCTable,function(T,n)
  local m,S,i,j;
  m:=Size(T)-2; # Old size
  S:=EmptySCTable(n,T[Size(T)]);
  for i in [1..m] do for j in [1..m] do
  S[i][j]:=T[i][j];
  od;od;
  return S;
  end
);

InstallGlobalFunction(MakeMultiplicationTable,function(C,n)
local G,K,R,L,B,N,m,T,h,d,c,i,j,k,l,BB,s,t,u,v,w,x; 
G:=C!.G; K:=C!.K; 
R:=C!.R; L:=C!.L; B:=C!.B;

# Setup the SC table.
N:=Sum(B{[1..n+1]});   # Size of new table
if IsBound(C!.T) then
  m:=Size(C!.T)-2;     # Size of old table
else 
  C!.T:=EmptySCTable(N,Zero(K));
  m:=1;
fi;
if m<N then C!.T:=AugmentSCTable(C!.T,N);fi;
T:=C!.T;
for i in [m..N] do
  T[1][i]:=[[i],[One(K)]];
  T[i][1]:=[[i],[One(K)]];
od;

# Create all cochains. 
if not IsBound(C!.h) then C!.h:=[];fi;
h:=C!.h; 
for j in [1..n] do
  if not IsBound(h[j]) then 
    BB:=Basis(FullRowSpace(K,B[j+1]));
    h[j]:=List(BB,x->[FirstLift(C,x)]);
  fi;
od;

# Lift maps and record products.
for i in [1..n-1] do
  for j in [1..Minimum(i,n-i)] do
    BB:=Basis(FullRowSpace(K,B[i+j+1]));
    for k in [1..B[i+1]] do
      c:=R[i+j]*LiftHom(L[1],h[i][k][j]);
      h[i][k][j+1]:=List(c,x->SolutionMat(C!.d[j],x));
      for l in [1..B[j+1]] do
        v:=ExtractColumn(h[i][k][j+1],(l-1)*Size(G)+1);
        # s and t are the positions of the elements
        # we're multiplying.
        s:=Sum(B{[1..i]})+k;
        t:=Sum(B{[1..j]})+l;
        # The following funny-looking lines just prepare 
        # the (t,s) and (s,t) entries of SC table. 
        u:=List([1..Sum(B{[1..i+j]})],x->Zero(K));
        Append(u,Coefficients(BB,v));
        w:=TransposedMat(ListX([1..Size(u)],
          x->u[x]<>Zero(K), x->[x,u[x]]));
        if w=[] then w:=[[],[]];fi;
        T[s][t]:=w;
        if i<>j then 
          x:=ShallowCopy(w);
          x[2]:=(-One(K))^(i*j)*x[2];
          T[t][s]:=x;
        fi;

      od;
    od;
  od;
od;
end
);
